--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):NewAddon("Inked", "AceEvent-3.0", "LibAboutPanel-2.0", "AceConsole-3.0")
--local LSM = LibStub("LibSharedMedia-3.0")
local Dialog = LibStub("AceConfigDialog-3.0")

local db
local defaults = {
    profile = {
		Draggables = {},
        lockframes = true,
		Restoreframes = false,
		--Generl Options Start
		AutoScreenShotOnLevel = true,
		AutoScreenShotOnAchievement = true,
		UseMiniMap = true,
		UseQuest = true,
		UseBags = true,
		UseAFK = true,
		UseIL = true,
		UseAutoRepair = true,
		UseAutoVender = true,
		UseCAS = true,
		UseNameplates = true,
		FasterLooting = true,
		--General Options End
		--MiniMapStart
		ShowClock = true,
		ShowZone = true,
		DisableCustomGraphics = false,
		MiniMapSize = 175,
		GraphicsClassColors = true,
		GraphicsCustomColors = false,
		GraphicsColorR = 1,
		GraphicsColorG = 1,
		GraphicsColorB = 1,
		GraphicsColorA = 1,
		GraphicsReset = false,
		ClassZoneColor = true,
		CustomZoneColor = false,
		ZoneColorR = 1,
		ZoneColorG = 1,
		ZoneColorB = 1,
		ZoneColorA = 1,
		Zonefont = "Roboto",
		ZoneOutline = "THINOUTLINE",
		ZoneFontSize = 18,
		ZoneReset = false,
		ClassClockColor = true,
		CustomClockColor = false,
		ClockColorR = 1,
		ClockColorG = 1,
		ClockColorB = 1,
		ClockColorA = 1,
		Clockfont = "Roboto",
		ClockOutline = "THINOUTLINE",
		ClockFontSize = 18,
		ClockReset = false,
		MoverMiniMapX = -45,
		MoverMiniMapY = -40,
		MoverMiniMapPoint = TOPRIGHT,
		--MiniMapEnd
		--Quest Tracker Start
		ObectiveTrackerScale = 1,
		ObectiveTrackerReset = false,
		ClassObectiveTrackerColor = true,
		CustomObectiveTrackerColor = false,
		ObectiveTrackerColorR = 1,
		ObectiveTrackerColorG = 1,
		ObectiveTrackerColorB = 1,
		ObectiveTrackerColorA = 1,
		ObectiveTrackerfont = "Roboto",
		ObectiveTrackerOutline = "THINOUTLINE",
		ObectiveTrackerFontSize = 18,
		MoverObjectiveTrackerX = -150,
		MoverObjectiveTrackerY = -245,
		--Quest Tracker End
		--ActionBar Start
		UseActionBars = true,
		InkBottleLeft = false,
		InkBottleRight = false,
		ClassABColor = true,
		CustomABColor = false,
		ABColorR = 1,
		ABColorG = 1,
		ABColorB = 1,
		ABColorA = 1,
		--ActionBar 1 Start
		MoverAB1X = -80,
		MoverAB1Y = 30,
		MoverAB1Point = 'BOTTOM',
		AB1ButtonSize = 35,
		AB1Layout = 1,

		AB1Reset = false,
		--ActionBar 1 End
		--ActionBar 2 Start
		MoverAB2X = -80,
		MoverAB2Y = 68,
		MoverAB2Point = 'BOTTOM',
		AB2ButtonSize = 35,
		AB2Layout = 1,

		AB2Reset = false,
		--ActionBar 2 End
		--ActionBar 3 Start
		MoverAB3X = -80,
		MoverAB3Y = 106,
		MoverAB3Point = 'BOTTOM',
		AB3ButtonSize = 35,
		AB3Layout = 1,

		AB3Reset = false,
		--ActionBar 3 End
		--ActionBar 4 Start
		MoverAB4X = -10,
		MoverAB4Y = 0,
		MoverAB4Point = 'RIGHT',
		AB4ButtonSize = 35,
		AB4Layout = 4,

		AB4Reset = false,
		--ActionBar 4 End
		--ActionBar 5 Start
		MoverAB5X = 210,
		MoverAB5Y = 32,
		MoverAB5Point = 'BOTTOM',
		AB5ButtonSize = 35,
		AB5Layout = 3,

		AB5Reset = false,
		--ActionBar 5 End
		--ActionBar 6 Start
		AB6Enable = false,
		MoverAB6X = 50,
		MoverAB6Y = 155,
		MoverAB6Point = 'BOTTOM',
		AB6ButtonSize = 35,
		Bar6BarLayout = 1,

		AB6Reset = false,
		--ActionBar 6 End
		--ActionBar 7 Start
		AB7Enable = false,
		MoverAB7X = 50,
		MoverAB7Y = 195,
		MoverAB7Point = 'BOTTOM',
		AB7ButtonSize = 35,
		Bar7BarLayout = 1,

		AB7Reset = false,
		--ActionBar 7 End
		--ActionBar 8 Start
		AB8Enable = false,
		MoverAB8X = 50,
		MoverAB8Y = 235,
		MoverAB8Point = 'BOTTOM',
		AB8ButtonSize = 35,
		Bar8BarLayout = 1,

		AB8Reset = false,
		--ActionBar 8 End
		--ActionBar 9 Start
		AB9Enable = false,
		MoverAB9X = 50,
		MoverAB9Y = 275,
		MoverAB9Point = 'BOTTOM',
		AB9ButtonSize = 35,
		Bar9BarLayout = 1,

		AB9Reset = false,
		--ActionBar 9 End
		--ActionBar 10 Start
		AB10Enable = false,
		MoverAB10X = 50,
		MoverAB10Y = 315,
		MoverAB10Point = 'BOTTOM',
		AB10ButtonSize = 35,
		Bar10BarLayout = 1,

		AB10Reset = false,
		--ActionBar 10 End
		--Stance Bar Start
		MoverStanceX = -122,
		MoverStanceY = 142,
		MoverStancePoint = BOTTOM,
		StanceButtonSize = 35,

		StanceReset = false,
		--Stance Bar End
		--Pet Action Bar Start
		MoverPetX = -80,
		MoverPetY = 142,
		MoverPetPoint = BOTTOM,
		PetButtonSize = 28,

		PetReset = false,
		--Pet Action Bar end
		--Bag Bar Start
		UseBagBar = true,
		BagBarShow = true,
		BagBarShowOnlyMainBag = false,
		BagBarX = -10,
		BagBarY = 10,
		BagBarPoint = BOTTOMRIGHT,
		Bagfont = "Roboto",
		BagOutline = "THINOUTLINE",
		BagFontSize = 15,
		ClassBagBarColor = true,
		CustomBagBarColor = false,
		BagBarColorR = 1,
		BagBarColorG = 1,
		BagBarColorB = 1,
		BagBarColorA = 1,
		BagBarReset = false,
		--BagBar end
		--XP Start
		XPEnable = true,
		XPX = -250,
		XPY = -10,
		XPPoint = TOP,
		XPWidth = 350,
		XPHeight = 24,
		XPfont = "Roboto",
		XPFontSize = 14,
		XPFontOutline = "THINOUTLINE",
		XPStatusBar = "Blizzard",
		XPReset = false,
		--XP end
		--MicroMenu Start
		MicroMenuEnabled = true,
		MicroMenuShow = true,
		MicroMenuX = 10,
		MicroMenuY = -10,
		MicroMenuPoint = TOPLEFT,
		ClassMicroMenuColor = true,
		CustomMicroMenuColor = false,
		MicroMenuColorR = 1,
		MicroMenuColorG = 1,
		MicroMenuColorB = 1,
		MicroMenuColorA = 1,
		MicroMenuReset = false,
		--MicroMenu end
		--Rep Start
		RepEnable = true,
		RepX = 250,
		RepY = -10,
		RepPoint = TOP,
		RepWidth = 350,
		RepHeight = 24,
		Repfont = "Roboto",
		RepFontSize = 14,
		RepFontOutline = "THINOUTLINE",
		RepStatusBar = "Blizzard",
		RepReset = false,
		--Rep end
		--Durability Start
		DuraEnable = true,
		DuraX = 525,
		DuraY = -10,
		DuraPoint = TOP,
		DuraWidth = 130,
		DuraHeight = 24,
		Durafont = "Roboto",
		DuraFontSize = 14,
		DuraFontOutline = "THINOUTLINE",
		DuraStatusBar = "Blizzard",
		DuraReset = false,
		--Durability end
		--Gold Start
		GoldEnable = true,
		GoldX = -250,
		GoldY = 10,
		GoldPoint = BOTTOMRIGHT,
		Goldfont = "Roboto",
		GoldFontSize = 18,
		GoldFontOutline = "THINOUTLINE",
		GoldReset = false,
		--Gold end
		--Vehicle
		VehicleX = 10,
		VehicleY = -50,
		--end Vehicle
		--NamePlates Start
		NamePlatefont = "Roboto",
		NamePlateStatusBar = "Blizzard",
		--end NamePlates
		--Chat Start
		ChatEnable = true,
		Chatfont = "Roboto",
		ChatFontSize = 14,
		ChatFontOutline = "THINOUTLINE",
		ChatEditBoxfont = "Roboto",
		ChatEditBoxFontSize = 14,
		ChatEditBoxFontOutline = "THINOUTLINE",
		ChatTabfont = "Roboto",
		ChatTabFontSize = 14,
		ChatTabFontOutline = "THINOUTLINE",
		RepReset = false,
		--Chat end
		--CVars Start
		CvarShowActionBars = true,
		CvarAutoLoot = true,
		CvarColorChatNamesByClass = true,
		CvarBuffDurations = true,
		CvarPredictedHealth = true,
		CvarCountdownForCooldowns = true,
		CvarNameplatePersonalShowAlways = true,
		CvarTutorials = true,
		--CVars end
		--PlayerFrame Start
		PlayerFrameEnable = true,
		PlayerPortrait = true,
		PlayerScale = 1,
		PlayerClassColor = true,
		PlayerCustomColor = false,
		PlayerColorR = 1,
		PlayerColorG = 1,
		PlayerColorB = 1,
		PlayerColorA = 1,
		PlayerShowLevel = true,
		PlayerShowName = true,
		PlayerShowHealthPercent = false,
		PlayerShowHealthNumbers = false,
		PlayerShowBothNumberandPercent = true,
		PlayerShowPowerPercent = false,
		PlayerShowPowerNumbers = false,
		PlayerShowBothPowerNumberandPercent = true,
		PlayerCastBar = true,
		PlayerAuras = true,
		PlayerFCF = true,
		PlayerHealthPrediction = true,
		PlayerLevelfont = "Roboto",
		PlayerLevelFontSize = 16,
		PlayerLevelOutline = "THINOUTLINE",
		PlayerNamefont = "Roboto",
		PlayerNameFontSize = 16,
		PlayerNameOutline = "THINOUTLINE",
		PlayerHealthfont = "Roboto",
		PlayerHealthFontSize = 16,
		PlayerHealthOutline = "THINOUTLINE",
		PlayerPowerfont = "Roboto",
		PlayerPowerFontSize = 16,
		PlayerPowerOutline = "THINOUTLINE",
		PlayerPVPfont = "Roboto",
		PlayerPVPFontSize = 16,
		PlayerPVPOutline = "THINOUTLINE",
		PlayerFloatingCombatTextfont = "Roboto",
		PlayerFloatingCombatTextFontSize = 24,
		PlayerFloatingCombatTextOutline = "THINOUTLINE",
		PlayerCastBarfont = "Roboto",
		PlayerCastBarFontSize = 16,
		PlayerCastBarOutline = "THINOUTLINE",
		PlayerHealthStatusBarClassClored = true,
		PlayerHealthStatusBar = "Blizzard",
		PlayerPowerStatusBar = "Blizzard",
		PlayerCastBarStatusBar = "Blizzard",
		PlayerX = -235,
		PlayerY = -250,
		PlayerPoint = CENTER,		
		--PlayerFrame End
		--TargetFrame Start
		TargetFrameEnable = true,
		TargetPortrait = true,
		TargetScale = 1,
		TargetShowLevel = true,
		TargetShowName = true,
		TargetShowHealthPercent = false,
		TargetShowHealthNumbers = false,
		TargetShowBothNumberandPercent = true,
		TargetShowPowerPercent = false,
		TargetShowPowerNumbers = false,
		TargetShowBothPowerNumberandPercent = true,
		TargetCastBar = true,
		TargetAuras = true,
		TargetFCF = true,
		TargetLevelfont = "Roboto",
		TargetLevelFontSize = 16,
		TargetLevelOutline = "THINOUTLINE",
		TargetNamefont = "Roboto",
		TargetNameFontSize = 16,
		TargetNameOutline = "THINOUTLINE",
		TargetHealthfont = "Roboto",
		TargetHealthFontSize = 16,
		TargetHealthOutline = "THINOUTLINE",
		TargetPowerfont = "Roboto",
		TargetPowerFontSize = 16,
		TargetPowerOutline = "THINOUTLINE",
		TargetFloatingCombatTextfont = "Roboto",
		TargetFloatingCombatTextFontSize = 24,
		TargetFloatingCombatTextOutline = "THINOUTLINE",
		TargetCastBarfont = "Roboto",
		TargetCastBarFontSize = 16,
		TargetCastBarOutline = "THINOUTLINE",
		TargetHealthStatusBarClassClored = true,
		TargetHealthStatusBar = "Blizzard",
		TargetPowerStatusBar = "Blizzard",
		TargetCastBarStatusBar = "Blizzard",
		TargetX = 35,
		TargetY = -250,
		TargetPoint = CENTER,
		--TargetFrame End
		--FocusFrame Start
		FocusFrameEnable = true,
		FocusPortrait = true,
		FocusScale = 1,
		FocusShowLevel = true,
		FocusShowName = true,
		FocusShowHealthPercent = false,
		FocusShowHealthNumbers = false,
		FocusShowBothNumberandPercent = true,
		FocusShowPowerPercent = false,
		FocusShowPowerNumbers = false,
		FocusShowBothPowerNumberandPercent = true,
		FocusCastBar = true,
		FocusAuras = true,
		FocusLevelfont = "Roboto",
		FocusLevelFontSize = 16,
		FocusLevelOutline = "THINOUTLINE",
		FocusNamefont = "Roboto",
		FocusNameFontSize = 16,
		FocusNameOutline = "THINOUTLINE",
		FocusHealthfont = "Roboto",
		FocusHealthFontSize = 16,
		FocusHealthOutline = "THINOUTLINE",
		FocusPowerfont = "Roboto",
		FocusPowerFontSize = 16,
		FocusPowerOutline = "THINOUTLINE",
		FocusCastBarfont = "Roboto",
		FocusCastBarFontSize = 16,
		FocusCastBarOutline = "THINOUTLINE",
		FocusHealthStatusBar = "Blizzard",
		FocusPowerStatusBar = "Blizzard",
		FocusCastBarStatusBar = "Blizzard",
		FocusX = -535,
		FocusY = 75,
		FocusPoint = CENTER,
		--FocusFrame End
		--PetFrame Start
		PetFrameEnable = true,
		PetScale = 1,
		PetShowLevel = true,
		PetShowName = true,
		PetShowHealthPercent = false,
		PetShowHealthNumbers = false,
		PetShowBothNumberandPercent = true,
		PetShowPowerPercent = false,
		PetShowPowerNumbers = false,
		PetShowBothPowerNumberandPercent = true,
		PetCastBar = true,
		PetAuras = true,
		PetLevelfont = "Roboto",
		PetLevelFontSize = 16,
		PetLevelOutline = "THINOUTLINE",
		PetNamefont = "Roboto",
		PetNameFontSize = 16,
		PetNameOutline = "THINOUTLINE",
		PetHealthfont = "Roboto",
		PetHealthFontSize = 10,
		PetHealthOutline = "THINOUTLINE",
		PetPowerfont = "Roboto",
		PetPowerFontSize = 10,
		PetPowerOutline = "THINOUTLINE",
		PetCastBarfont = "Roboto",
		PetCastBarFontSize = 10,
		PetCastBarOutline = "THINOUTLINE",
		PetHealthStatusBar = "Blizzard",
		PetPowerStatusBar = "Blizzard",
		PetCastBarStatusBar = "Blizzard",
		PetX = -390,
		PetY = -360,
		PetPoint = CENTER,
		--PetFrame End
		--ToTFrame Start
		ToTFrameEnable = true,
		ToTScale = 1,
		ToTShowName = true,
		ToTShowHealthPercent = true,
		ToTShowPowerPercent = true,
		ToTNamefont = "Roboto",
		ToTNameFontSize = 10,
		ToTNameOutline = "THINOUTLINE",
		ToTHealthfont = "Roboto",
		ToTHealthFontSize = 10,
		ToTHealthOutline = "THINOUTLINE",
		ToTPowerfont = "Roboto",
		ToTPowerFontSize = 10,
		ToTPowerOutline = "THINOUTLINE",
		ToTHealthStatusBar = "Blizzard",
		ToTPowerStatusBar = "Blizzard",
		ToTX = 235,
		ToTY = -335,
		ToTPoint = CENTER,
		--ToTFrame End
		--FTFrame Start
		FTFrameEnable = true,
		FTScale = 1,
		FTShowName = true,
		FTShowHealthPercent = true,
		FTShowPowerPercent = true,
		FTNamefont = "Roboto",
		FTNameFontSize = 10,
		FTNameOutline = "THINOUTLINE",
		FTHealthfont = "Roboto",
		FTHealthFontSize = 10,
		FTHealthOutline = "THINOUTLINE",
		FTPowerfont = "Roboto",
		FTPowerFontSize = 10,
		FTPowerOutline = "THINOUTLINE",
		FTHealthStatusBar = "Blizzard",
		FTPowerStatusBar = "Blizzard",
		FTX = -435,
		FTY = -35,
		FTPoint = CENTER,
		--FTFrame End
		--Party Start
		EnableParty = true,
		ShowSolo = false,
		PartyAuras = true,
		PartyNamefont = "Roboto",
		PartyNameFontSize = 15,
		PartyNameOutline = "THINOUTLINE",
		PartyHealthfont = "Roboto",
		PartyHealthFontSize = 15,
		PartyHealthOutline = "THINOUTLINE",
		PartyPowerfont = "Roboto",
		PartyPowerFontSize = 15,
		PartyPowerOutline = "THINOUTLINE",
		PartyLevelfont = "Roboto",
		PartyLevelFontSize = 15,
		PartyLevelOutline = "THINOUTLINE",
		PartyHealthStatusBar = "Blizzard",
		PartyPowerStatusBar = "Blizzard",
		PartyX = 120,
		PartyY = -250,
		PartyPoint = TOPLEFT,
		--Party Start
    }
}
function Inked:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("InkedDB", defaults,true,true)
   db = self.db.profile
  local InkedOptions = self:GetOptions()
  LibStub("AceConfig-3.0"):RegisterOptionsTable("Inked", InkedOptions)
  InkedOptions.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(Inked.db)
  InkedOptions.args.aboutTab = self:AboutOptionsTable("Inked")
  InkedOptions.args.aboutTab.order = -1
  self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
  self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
  self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
   self.optionsFrame = Dialog:AddToBlizOptions("Inked", "Inked")
   Dialog:SetDefaultSize("Inked", 775, 725)
end

function Inked:RefreshConfig()
	for i, j in pairs(defaults) do
		if type(j) == "table" then
			if defaults[i] == nil then defaults[i] = {} end
			for k, v in pairs(j) do
				if defaults[i][k] == nil then
					defaults[i][k] = v
				end
			end
		else
			if defaults[i] == nil then defaults[i] = j end
		end
	end
	db = self.db
	ReloadUI()
end

	SLASH_Inked1 = "/Inked"
	SLASH_Inked2 = "/Ink"
	SLASH_Inked3 = "/NK"
	_G.SlashCmdList.RELOADUI = ReloadUI
	SLASH_RELOADUI1 = "/rl"
	SlashCmdList["Inked"] = function() 
	Dialog:Open("Inked")
	end

local frame = CreateFrame("Button","UIPanelButtonTemplateTest", GameMenuFrame, "UIPanelButtonTemplate")
		GameMenuButtonHelp:Hide()--Hiding the help Button
		frame:SetHeight(20) --our button height
		frame:SetWidth(145) --our button width
		frame:SetText("Inked")--the test for the button
		frame:ClearAllPoints()--clearing the points so t can be set
		frame:SetPoint("TOP", 0, -30)--setting our button where the help button should be
		frame:RegisterForClicks("AnyUp")--make it so it can be clicked
			frame:SetScript("OnClick", function()--add the click function
				Dialog:Open("Inked") HideUIPanel(GameMenuFrame)--what we want to happen, in this case I want my options menu to show
			end )